Index: springapp/src/main/java/mk/profesori/springapp/Service/MainService.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Service/MainService.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Service/MainService.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -3,4 +3,6 @@
 import mk.profesori.springapp.Model.*;
 import mk.profesori.springapp.Repository.*;
+import mk.profesori.springapp.Service.Exception.DisallowedOperationException;
+import mk.profesori.springapp.Service.Exception.IncompatiblePostId;
 import org.springframework.security.core.userdetails.UsernameNotFoundException;
 import org.springframework.stereotype.Service;
@@ -9,4 +11,5 @@
 import java.util.ArrayList;
 import java.util.List;
+import java.util.Set;
 
 @Service
@@ -24,6 +27,7 @@
     private final UserRepository userRepository;
     private final PostReportRepository postReportRepository;
-
-    public MainService(ProfessorRepository professorRepository, StudyProgrammeRepository studyProgrammeRepository, FacultyRepository facultyRepository, UniversityRepository universityRepository, CityRepository cityRepository, OpinionRepository opinionRepository, _ThreadRepository _threadRepository, SubjectRepository subjectRepository, PostVoteRepository postVoteRepository, UserRepository userRepository, PostReportRepository postReportRepository) {
+    private final PostRepository postRepository;
+
+    public MainService(ProfessorRepository professorRepository, StudyProgrammeRepository studyProgrammeRepository, FacultyRepository facultyRepository, UniversityRepository universityRepository, CityRepository cityRepository, OpinionRepository opinionRepository, _ThreadRepository _threadRepository, SubjectRepository subjectRepository, PostVoteRepository postVoteRepository, UserRepository userRepository, PostReportRepository postReportRepository, PostRepository postRepository) {
         this.professorRepository = professorRepository;
         this.studyProgrammeRepository = studyProgrammeRepository;
@@ -37,4 +41,5 @@
         this.userRepository = userRepository;
         this.postReportRepository = postReportRepository;
+        this.postRepository = postRepository;
     }
 
@@ -58,4 +63,8 @@
     public List<Professor> getProfessorsByNameContains(String contained) {
         return new ArrayList<>(professorRepository.findByProfessorNameContainingIgnoreCase(contained));
+    }
+
+    public List<Subject> getSubjectsByNameContains(String contained) {
+        return new ArrayList<>(subjectRepository.findBySubjectNameContainingIgnoreCase(contained));
     }
 
@@ -200,5 +209,5 @@
     public void delete_Thread(Long postId) {_threadRepository.deleteById(postId);}
 
-    public String updateOpinion(String newContent, Long newTargetProfessorId, Long newParentPostId, Long postId) {
+    public void updateOpinion(String newContent, Long newTargetProfessorId, Long newParentPostId, Long postId) {
         Opinion opinionToUpdate = opinionRepository.findByPostId(postId);
 
@@ -218,14 +227,22 @@
         opinionToUpdate.setParent(newParentOpinion);
 
+        propagateNewTargetProfessorToChildren(opinionToUpdate, newTargetProfessor);
+
+        opinionToUpdate.setTimeLastEdited(LocalDateTime.now());
+        opinionRepository.save(opinionToUpdate);
+    }
+
+    public void propagateNewTargetProfessorToChildren(Opinion opinionToUpdate, Professor newTargetProfessor) {
         for(Post p : opinionToUpdate.getChildren()) {
+            // direct children
             Opinion o = (Opinion) p;
             o.setTargetProfessor(newTargetProfessor);
+            // ancestors
+            if(o.getChildren().isEmpty()) return;
+            propagateNewTargetProfessorToChildren(o, newTargetProfessor);
         }
-        opinionToUpdate.setTimeLastEdited(LocalDateTime.now());
-        opinionRepository.save(opinionToUpdate);
-        return null;
-    }
-
-    public String update_Thread(String newTitle, String newContent, Long newTargetSubjectId, Long newParentThreadId, Long postId) {
+    }
+
+    public void update_Thread(String newTitle, String newContent, Long newTargetSubjectId, Long newParentThreadId, Long postId) {
         _Thread _threadToUpdate = _threadRepository.findByPostId(postId);
 
@@ -251,11 +268,19 @@
             }
 
-         for(Post p : _threadToUpdate.getChildren()) {
-                _Thread t = (_Thread) p;
-                t.setTargetSubject(newTargetSubject);
-            }
+         propagateNewTargetSubjectToChildren(_threadToUpdate, newTargetSubject);
+
          _threadToUpdate.setTimeLastEdited(LocalDateTime.now());
           _threadRepository.save(_threadToUpdate);
-          return null;
+    }
+
+    public void propagateNewTargetSubjectToChildren(_Thread _threadToUpdate, Subject newTargetSubject) {
+        for(Post p : _threadToUpdate.getChildren()) {
+            // direct children
+            _Thread t = (_Thread) p;
+            t.setTargetSubject(newTargetSubject);
+            // ancestors
+            if (t.getChildren().isEmpty()) return;
+            propagateNewTargetSubjectToChildren(t, newTargetSubject);
+        }
     }
 
@@ -306,3 +331,48 @@
         postReportRepository.save(reportToAdd);
     }
+
+    public List<Opinion> getRelatedOpinions(Long professorId) {
+        Professor p = professorRepository.findByProfessorId(professorId);
+        return opinionRepository.findByTargetProfessor(p);
+    }
+
+    public List<Opinion> getLatest10Opinions() {
+        return opinionRepository.findTop10ByOrderByTimePosted();
+    }
+    public List<_Thread> getLatest10Threads() {
+        return _threadRepository.findTop10ByOrderByTimePosted();
+    }
+
+    public List<String> getUniversitySectionAndPostCount() {
+        return universityRepository.findSectionAndPostCount();
+    }
+
+    public List<Subject> getSubjectsByStudyProgramme(Long studyProgrammeId) {
+        StudyProgramme sp = studyProgrammeRepository.findByStudyProgrammeId(studyProgrammeId);
+        return subjectRepository.findByStudyProgramme(sp);
+    }
+
+    public List<String> getOpinionCountForEachProfessorInFaculty(Long id) {
+        return facultyRepository.getOpinionCountForEachProfessorInFaculty(id);
+    }
+
+    public List<_Thread> getThreadsBySubject(Long id) {
+        Subject s = subjectRepository.findBySubjectId(id);
+        return _threadRepository.findByTargetSubject(s);
+    }
+
+    public List<String> getThreadCountForEachSubjectInStudyProgramme(Long id) {
+        return studyProgrammeRepository.getThreadCountForEachSubjectInStudyProgramme(id);
+    }
+
+    public Set<Post> getPostsByUser(String email) {
+        CustomUserDetails u = userRepository.findByEmail(email).orElseThrow(
+                () -> new UsernameNotFoundException(String.format("User with email %s not found", email)));
+        return postRepository.findByAuthor(u);
+    }
+
+    public CustomUserDetails getPublicUserProfile(Long id) {
+        return userRepository.findById(id).orElseThrow(
+                () -> new UsernameNotFoundException(String.format("User with id %d not found", id)));
+    }
 }
Index: springapp/src/main/java/mk/profesori/springapp/Service/RegistrationService.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Service/RegistrationService.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Service/RegistrationService.java	(revision 9bf1f8db5dd66185ddc4f7d093582ff73006f66b)
@@ -45,5 +45,5 @@
                 String tokenToResend = customUserDetailsService
                         .createToken(userRepository.findByEmail(request.getEmail()).get());
-                String link = "http://192.168.0.29:8080/registration/confirm?token=" + tokenToResend;
+                String link = "http://192.168.1.254:8080/registration/confirm?token=" + tokenToResend;
                 emailSender.send(request.getEmail(), emailSender.buildEmail(request.getUsername(), link));
                 return tokenToResend;
@@ -66,5 +66,5 @@
                         UserRole.REGULAR));
 
-        String link = "http://192.168.0.29:8080/registration/confirm?token=" + token;
+        String link = "http://192.168.1.254:8080/registration/confirm?token=" + token;
 
         emailSender.send(request.getEmail(), emailSender.buildEmail(request.getUsername(), link));
